Index: trunk/sources/HeuristicLab.Common.Resources/3.2/HeuristicLab.Common.Resources-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Common.Resources/3.2/HeuristicLab.Common.Resources-3.2.csproj	(revision 2625)
+++ trunk/sources/HeuristicLab.Common.Resources/3.2/HeuristicLab.Common.Resources-3.2.csproj	(revision 2626)
@@ -88,8 +88,39 @@
       <DependentUpon>Resources.resx</DependentUpon>
     </Compile>
+    <Compile Include="VS2008ImageLibrary.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>VS2008ImageLibrary.resx</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
+    <None Include="Resources\CopyIcon.png" />
+    <None Include="Resources\CutIcon.png" />
+    <None Include="Resources\DeleteFolderIcon.png" />
+    <None Include="Resources\DeleteIcon.png" />
+    <None Include="Resources\FlagBlueIcon.png" />
+    <None Include="Resources\FlagGreenIcon.png" />
+    <None Include="Resources\FlagRedIcon.png" />
+    <None Include="Resources\FormulaEvaluatorIcon.png" />
+    <None Include="Resources\FunctionIcon.png" />
+    <None Include="Resources\HeuristicLab.ico" />
+    <None Include="Resources\HeuristicLab.png" />
+    <None Include="Resources\NewFolderIcon.png" />
+    <None Include="Resources\NewIcon.png" />
+    <None Include="Resources\OpenIcon.png" />
+    <None Include="Resources\PasteIcon.png" />
+    <None Include="Resources\PrintIcon.png" />
+    <None Include="Resources\PrintPreviewIcon.png" />
+    <None Include="Resources\RedoIcon.png" />
+    <None Include="Resources\RefreshDocument.png" />
+    <None Include="Resources\SaveAllIcon.png" />
+    <None Include="Resources\SaveIcon.png" />
+    <None Include="Resources\ShowDetails.png" />
+    <None Include="Resources\ShowLargeIcons.png" />
+    <None Include="Resources\ShowSmallIcons.png" />
+    <None Include="Resources\UndoIcon.png" />
+    <None Include="Resources\WarningIcon.png" />
   </ItemGroup>
   <ItemGroup>
@@ -105,82 +136,20 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
+    <EmbeddedResource Include="VS2008ImageLibrary.resx">
+      <Generator>PublicResXFileCodeGenerator</Generator>
+      <LastGenOutput>VS2008ImageLibrary.Designer.cs</LastGenOutput>
+    </EmbeddedResource>
   </ItemGroup>
   <ItemGroup>
-    <None Include="Resources\OpenIcon.png" />
+    <None Include="Resources\VS2008ImageLibrary_CommonElements_Actions_Add.png" />
   </ItemGroup>
   <ItemGroup>
-    <None Include="Resources\NewIcon.png" />
+    <None Include="Resources\VS2008ImageLibrary_CommonElements_Actions_Remove.png" />
   </ItemGroup>
   <ItemGroup>
-    <None Include="Resources\SaveIcon.png" />
+    <None Include="Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Down.png" />
   </ItemGroup>
   <ItemGroup>
-    <None Include="Resources\SaveAllIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\PrintIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\PrintPreviewIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\CopyIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\CutIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\PasteIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\DeleteIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\DeleteFolderIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\RedoIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\UndoIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\NewFolderIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\HeuristicLab.ico" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\WarningIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\FlagBlueIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\FlagGreenIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\FlagRedIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\FormulaEvaluatorIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\FunctionIcon.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\RefreshDocument.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\ShowDetails.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\ShowLargeIcons.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\ShowSmallIcons.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\HeuristicLab.png" />
+    <None Include="Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Up.png" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.Designer.cs	(revision 2626)
+++ trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.Designer.cs	(revision 2626)
@@ -0,0 +1,91 @@
+﻿//------------------------------------------------------------------------------
+// <auto-generated>
+//     This code was generated by a tool.
+//     Runtime Version:2.0.50727.4200
+//
+//     Changes to this file may cause incorrect behavior and will be lost if
+//     the code is regenerated.
+// </auto-generated>
+//------------------------------------------------------------------------------
+
+namespace HeuristicLab.Common.Resources {
+    using System;
+    
+    
+    /// <summary>
+    ///   A strongly-typed resource class, for looking up localized strings, etc.
+    /// </summary>
+    // This class was auto-generated by the StronglyTypedResourceBuilder
+    // class via a tool like ResGen or Visual Studio.
+    // To add or remove a member, edit your .ResX file then rerun ResGen
+    // with the /str option, or rebuild your VS project.
+    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("System.Resources.Tools.StronglyTypedResourceBuilder", "2.0.0.0")]
+    [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+    [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
+    public class VS2008ImageLibrary {
+        
+        private static global::System.Resources.ResourceManager resourceMan;
+        
+        private static global::System.Globalization.CultureInfo resourceCulture;
+        
+        [global::System.Diagnostics.CodeAnalysis.SuppressMessageAttribute("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")]
+        internal VS2008ImageLibrary() {
+        }
+        
+        /// <summary>
+        ///   Returns the cached ResourceManager instance used by this class.
+        /// </summary>
+        [global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
+        public static global::System.Resources.ResourceManager ResourceManager {
+            get {
+                if (object.ReferenceEquals(resourceMan, null)) {
+                    global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager("HeuristicLab.Common.Resources.VS2008ImageLibrary", typeof(VS2008ImageLibrary).Assembly);
+                    resourceMan = temp;
+                }
+                return resourceMan;
+            }
+        }
+        
+        /// <summary>
+        ///   Overrides the current thread's CurrentUICulture property for all
+        ///   resource lookups using this strongly typed resource class.
+        /// </summary>
+        [global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
+        public static global::System.Globalization.CultureInfo Culture {
+            get {
+                return resourceCulture;
+            }
+            set {
+                resourceCulture = value;
+            }
+        }
+        
+        public static System.Drawing.Bitmap Add {
+            get {
+                object obj = ResourceManager.GetObject("Add", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        public static System.Drawing.Bitmap ArrowDown {
+            get {
+                object obj = ResourceManager.GetObject("ArrowDown", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        public static System.Drawing.Bitmap ArrowUp {
+            get {
+                object obj = ResourceManager.GetObject("ArrowUp", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        public static System.Drawing.Bitmap Remove {
+            get {
+                object obj = ResourceManager.GetObject("Remove", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+    }
+}
Index: trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.resx
===================================================================
--- trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.resx	(revision 2626)
+++ trunk/sources/HeuristicLab.Common.Resources/3.2/VS2008ImageLibrary.resx	(revision 2626)
@@ -0,0 +1,133 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+  <data name="Add" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>Resources\VS2008ImageLibrary_CommonElements_Actions_Add.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="ArrowDown" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Down.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="ArrowUp" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Up.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="Remove" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>Resources\VS2008ImageLibrary_CommonElements_Actions_Remove.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+</root>