Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs	(revision 2635)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/Actions/NewEditorAction.cs	(revision 2636)
@@ -7,9 +7,8 @@
 namespace HeuristicLab.MainForm.Test {
   public static class NewEditorAction{
-    private static IView view;
+
     public static void Execute(IMainForm mainform) {
-      if (view == null)
-        view = new EditorView();
-      view.Caption = "Editor View";
+      EditorView view = new EditorView();
+      view.Caption = "Editor View " + mainform.Views.Count();
       mainform.ShowView(view);
     }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2635)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2636)
@@ -22,4 +22,10 @@
       new OpenAction().Execute(MainFormManager.MainForm);
     }
+
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      this.ToolStripItem.Enabled = !this.ToolStripItem.Enabled;
+      MainFormManager.MainForm.Title = 
+        MainFormManager.MainForm.ActiveView == null ? "null" : MainFormManager.MainForm.ActiveView.Caption;
+    }
   }
 }
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.Designer.cs	(revision 2635)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.Designer.cs	(revision 2636)
@@ -115,4 +115,5 @@
       this.dockPanel.Skin = dockPanelSkin1;
       this.dockPanel.TabIndex = 3;
+      this.dockPanel.ActiveContentChanged += new System.EventHandler(this.dockPanel_ActiveContentChanged);
       // 
       // DockingMainForm
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 2635)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 2636)
@@ -67,4 +67,8 @@
     }
 
+    private void dockPanel_ActiveContentChanged(object sender, EventArgs e) {
+      DockForm content = this.dockPanel.ActiveContent as DockForm;
+      this.ActiveView = content == null ? null : content.View;
+    }
   }
 }
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2635)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainFormBase.cs	(revision 2636)
@@ -176,5 +176,4 @@
           views[view] = form;
           form.Activated += new EventHandler(FormActivated);
-          form.GotFocus += new EventHandler(FormActivated);
           form.FormClosing += new FormClosingEventHandler(view.OnClosing);
           form.FormClosing += new FormClosingEventHandler(((ViewBase)view).OnClosingHelper);
@@ -192,5 +191,5 @@
     }
 
-    protected virtual void Show(IView view, bool firstTimeShown) {      
+    protected virtual void Show(IView view, bool firstTimeShown) {
     }
 
@@ -245,5 +244,4 @@
 
       form.Activated -= new EventHandler(FormActivated);
-      form.GotFocus -= new EventHandler(FormActivated);
       form.FormClosing -= new FormClosingEventHandler(view.OnClosing);
       form.FormClosing -= new FormClosingEventHandler(((ViewBase)view).OnClosingHelper);
@@ -269,6 +267,5 @@
 
     #region create menu and toolbar
-    protected virtual void CreateGUI() {      
-
+    protected virtual void CreateGUI() {
       IEnumerable<IMenuItem> toolStripMenuItems =
         from mi in ApplicationManager.Manager.GetInstances(userInterfaceItemType)